# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Revive
execute at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run tag @p[distance=..2,gamemode=spectator] add Revive
execute at @a[tag=Revive] run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}}},limit=1,distance=..5]
execute at @a[tag=Revive] run gamemode survival @p
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:slowness 60 1 true
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:weakness 60 1 true
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:glowing 60 1 true
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:hunger 60 1 true
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:mining_fatigue 60 1 true
execute if score hcr_settings hcrReviveDebuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:poison 2 0 true
execute at @a[tag=Revive] run playsound minecraft:ui.toast.challenge_complete master @a ~ ~ ~ 10 1
execute at @a[tag=Revive] run tag @p remove Revive

# Detect deaths
execute as @a[scores={deaths=1..}] run function hcrplus:death

# Set spawn
execute at @a[scores={health=0}] if dimension minecraft:overworld run spawnpoint @p ~ ~1 ~
execute at @a[scores={health=0}] if dimension minecraft:the_nether run spawnpoint @p ~ ~1 ~

# Ghost particles
execute at @a[gamemode=spectator] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Scare mobs
execute at @a[gamemode=spectator] run tag @e[type=!minecraft:player,distance=..0.8] add Scared
data modify entity @e[tag=Scared,limit=1,nbt=!{TicksFrozen:0}] TicksFrozen set value 140
effect give @e[tag=Scared,nbt=!{active_effects:[{id:"minecraft:wither"}]}] minecraft:wither 3 0 true

tag @e[type=!minecraft:player] remove Scared

# Possess players
execute at @a[gamemode=spectator] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Health buffs
execute as @a[scores={lifeJelly=0}] run attribute @s minecraft:generic.max_health base set 20
execute as @a[scores={lifeJelly=1}] run attribute @s minecraft:generic.max_health base set 24

# Fix scores
scoreboard players set @a[tag=!nHrCheck] lifeJelly 0
tag @a add nHrCheck

# Default settings
execute unless score hcr_settings hcrLoaded matches 1 run scoreboard players set hcr_settings hcrLifeJelly 1
execute unless score hcr_settings hcrLoaded matches 1 run scoreboard players set hcr_settings hcrSoulCharmDebuffs 1
execute unless score hcr_settings hcrLoaded matches 1 run scoreboard players set hcr_settings hcrReviveDebuffs 1
scoreboard players set hcr_settings hcrLoaded 1